From 3b96f434d3f0c8a47eb959bd69bd80fb84da62aa Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Mon, 3 Feb 2020 18:21:04 +0300
Subject: [PATCH 11/59] AlpineApk{Updater,AuthHelper}: pass fakeRoot to helper

Env vars are not inherited by elevated helper
---
 .../backends/AlpineApkBackend/AlpineApkAuthHelper.cpp | 11 ++++++++++-
 .../backends/AlpineApkBackend/AlpineApkUpdater.cpp    |  5 ++++-
 2 files changed, 14 insertions(+), 2 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
index 4ff5c880a..aa3dbdae1 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkAuthHelper.cpp
@@ -64,9 +64,13 @@ ActionReply AlpineApkAuthHelper::test(const QVariantMap &args)
 
 ActionReply AlpineApkAuthHelper::update(const QVariantMap &args)
 {
-    Q_UNUSED(args)
     ActionReply reply = ActionReply::HelperErrorReply();
 
+    const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
+    if (!fakeRoot.isEmpty()) {
+        m_apkdb.setFakeRoot(fakeRoot);
+    }
+
     HelperSupport::progressStep(10);
 
     if (!m_apkdb.open(QtApk::Database::QTAPK_OPENF_READWRITE)) {
@@ -125,6 +129,11 @@ ActionReply AlpineApkAuthHelper::upgrade(const QVariantMap &args)
         qCDebug(LOG_AUTHHELPER) << "Simulating upgrade run.";
     }
 
+    const QString fakeRoot = args.value(QLatin1String("fakeRoot"), QString()).toString();
+    if (!fakeRoot.isEmpty()) {
+        m_apkdb.setFakeRoot(fakeRoot);
+    }
+
     QtApk::Changeset changes;
     bool upgrade_ok = m_apkdb.upgrade(flags, &changes);
 
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
index 1dd6cdacd..d0c0482ef 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkUpdater.cpp
@@ -47,6 +47,7 @@ void AlpineApkUpdater::prepare()
         return;
     }
 
+    // readonly is fine for a simulation of upgrade
     if (!db->open(QtApk::Database::QTAPK_OPENF_READONLY)) {
         emit passiveMessage(i18n("Failed to open APK database!"));
         return;
@@ -57,7 +58,7 @@ void AlpineApkUpdater::prepare()
         db->close();
         return;
     }
-    // clsoe DB ASAP
+    // close DB ASAP
     db->close();
 
     m_updatesCount = m_upgradeable.changes().size();
@@ -202,6 +203,7 @@ int AlpineApkUpdater::updatesCount()
 
 void AlpineApkUpdater::startCheckForUpdates()
 {
+    QtApk::Database *db = m_backend->apkdb();
     KAuth::Action updateAction(QStringLiteral("org.kde.discover.alpineapkbackend.update"));
     updateAction.setHelperId(QStringLiteral("org.kde.discover.alpineapkbackend"));
     if (!updateAction.isValid()) {
@@ -210,6 +212,7 @@ void AlpineApkUpdater::startCheckForUpdates()
     }
     updateAction.setTimeout(60 * 1000); // 1 minute
     updateAction.setDetails(i18n("Update repositories index"));
+    updateAction.addArgument(QLatin1String("fakeRoot"), db->fakeRoot());
 
     // run updates check with elevated privileges to access
     // system package manager files
-- 
GitLab


